name: Python package

on:
  push:
    branches: [ master ]
  pull_request:
    branches: [ master ]
  workflow_dispatch:

jobs:
  build:

    runs-on: ubuntu-latest
    strategy:
      fail-fast: false
      matrix:
        python-version: [3.7, 3.8, 3.9, "3.10", "3.11"]
        django-version: [1.8, 1.9, "1.10", 1.11, 2.0, 2.1, 2.2, 3.0, 3.1, 3.2, 4.0, 4.1, 4.2]
        exclude:

          - python-version: 3.11
            django-version: 1.8
          - python-version: 3.11
            django-version: 1.9
          - python-version: 3.11
            django-version: "1.10"
          - python-version: 3.11
            django-version: 1.11
          - python-version: 3.11
            django-version: 2.1

          - python-version: 3.10
            django-version: 1.8
          - python-version: 3.10
            django-version: 1.9
          - python-version: 3.10
            django-version: "1.10"
          - python-version: 3.10
            django-version: 1.11

          - python-version: 3.9
            django-version: 1.8
          - python-version: 3.9
            django-version: 1.9
          - python-version: 3.9
            django-version: "1.10"

          - python-version: 3.8
            django-version: 1.8
          - python-version: 3.8
            django-version: 1.9
          - python-version: 3.8
            django-version: "1.10"

          - python-version: 3.7
            django-version: 1.8
          - python-version: 3.7
            django-version: 4.0
          - python-version: 3.7
            django-version: 4.1
          - python-version: 3.7
            django-version: 4.2

    steps:
    - uses: actions/checkout@v2
    - name: Set up Python ${{ matrix.python-version }} & Django ${{ matrix.django-version }}
      uses: actions/setup-python@v2
      with:
        python-version: ${{ matrix.python-version }}
    - name: Install deps
      run: |
        python -m pip install pytest coverage coveralls "Django~=${{ matrix.django-version }}.0"
    - name: Run tests
      env:
        GITHUB_TOKEN: ${{ secrets.github_token }}
      run: |
        coverage run --source=pytest_djangoapp setup.py test
        coveralls --service=github
